
#define KeyEn porta.6
#define KeyEnTris trisa.6
#define KeyTris trisb

#define KeyDelay 30
#define KeyRepeat 10

#define key_none    0
#define key_back    1
#define key_up      2
#define key_dw      3
#define key_enter   4

unsigned char keys=0,previous,edges,KeyCount;

char ReadKeyPad(){
char i;
    previous=keys;
    option_reg.7=0;
    KeyTris|=0x3c;
    KeyEnTris=0;
    KeyEn=0;
    keys=(portb>>2)&0x0f;
    keys^=0x0f;
    KeyTris&=0xc3;
    KeyEn=1;
    if(keys==0)
        return(0);
    if(((keys^previous)&keys)==0){
        //repeating key
        if(--KeyCount!=0)
            return(0);
        KeyCount=KeyRepeat;
    }else{
        //must be new key
        KeyCount=KeyDelay;
        edges=((keys^previous)&keys);
    }
    i=0;
    while((edges&(1<<i))==0){
        i++;
    }
    return (++i);
}

